<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- qtcreator-ui-text.qdoc -->
  <title>User Interface Text Guidelines | Extending Qt Creator Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="extending-index.html">Extending Qt Creator Manual</a></td><td >User Interface Text Guidelines</td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right"><a href="extending-index.html">Extending Qt Creator Manual 4.11.1</a></td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
  <link rel="prev" href="external-tool-spec.html" />
  <link rel="next" href="coding-style.html" />
<p class="naviNextPrevious headerNavi">
<a class="prevPage" href="external-tool-spec.html">External Tool Specification Files</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="coding-style.html">Qt Creator Coding Rules</a>
</p><p/>
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#grammar-and-style">Grammar and Style</a></li>
<li class="level1"><a href="#punctuation">Punctuation</a></li>
<li class="level2"><a href="#writing-tooltips">Writing Tooltips</a></li>
<li class="level2"><a href="#writing-messages">Writing Messages</a></li>
<li class="level1"><a href="#ui-text-capitalization">UI Text Capitalization</a></li>
<li class="level2"><a href="#using-book-style-capitalization">Using Book Style Capitalization</a></li>
<li class="level2"><a href="#using-sentence-style-capitalization">Using Sentence Style Capitalization</a></li>
<li class="level1"><a href="#preparing-for-localization">Preparing for Localization</a></li>
<li class="level2"><a href="#marking-ui-text-for-translation">Marking UI Text for Translation</a></li>
<li class="level2"><a href="#features-of-languages-or-writing-systems">Features of Languages or Writing Systems</a></li>
<li class="level1"><a href="#common-qt-creator-terms">Common Qt Creator Terms</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">User Interface Text Guidelines</h1>
<span class="subtitle"></span>
<!-- $$$qtcreator-ui-text.html-description -->
<div class="descr"> <a name="details"></a>
<p>Follow the guidelines in this section to make sure that your extensions are consistent with the Qt Creator UI and that they can be easily localized into different languages.</p>
<p>When you write UI text, make sure that it is:</p>
<ul>
<li>Consistent with existing Qt Creator UI terms</li>
<li>Short and concise</li>
<li>Neutral, descriptive, and factually correct</li>
<li>Unambigious</li>
<li>Translatable into different languages</li>
</ul>
<a name="grammar-and-style"></a>
<h2 id="grammar-and-style">Grammar and Style</h2>
<p>All UI text must be grammatically correct English and use the standard form of written language. Do not use dialect or slang words. Use idiomatic language, that is, expressions that are characteristic for English. If possible, ask a native English speaker for a review.</p>
<p>UI text should be concise and economically formulated. Avoid unnecessary content words and phrases. However, it is more important that the text is useful and easy to understand.</p>
<p>Avoid addressing the user in the second person. Use a neutral tone or passive voice but use a formal address when necessary. Avoid using the word <i>Please</i> when addressing the user. Exceptions to this are some copyright text and short imperative sentences that might otherwise sound abrupt. For example, <i>Please wait.</i></p>
<p>Avoid abbreviations in the menu names and items. If there is no room for the full spelling or hyphenation of a word, abbreviate the text according to the English abbreviation rules.</p>
<p>Avoid contractions. For example, write <i>cannot</i> instead of <i>can't</i>.</p>
<a name="punctuation"></a>
<h2 id="punctuation">Punctuation</h2>
<p>Avoid using punctuation marks or special characters in menu names and items.</p>
<p>Use punctuation marks as follows:</p>
<ul>
<li>Use full stops in messages.</li>
<li>Never use full stops (.) at the end of menu item names.</li>
<li>Place three full stops (..&#x2e;) at the end of menu item names that open a dialog requiring user action.</li>
<li>Use exclamation marks (!) only in text that demands extra attention from the user or carries special weight.</li>
<li>Use quotation marks (&quot;&quot;) around variable values. For example, <b>Close Project &quot;qtcreator&quot;</b>. For consistency, use double quotes to emphasize or set apart file names, directory names, URLs, and so on, in user visible strings.</li>
<li>Do not use leading, trailing, or multiple spaces to align text in messages, as translation tools might not handle them correctly.</li>
</ul>
<a name="writing-tooltips"></a>
<h3 id="writing-tooltips">Writing Tooltips</h3>
<p>Tooltips contain useful information about icons, menu items, or other UI elements. They appear when users place the mouse pointer over an UI element. You can also add descriptive text to the UI that is always visible.</p>
<p>For an icon, you can use the command name as a tool tip. In that case, use book style capitalization and do not add a period after the tool tip.</p>
<p class="centerAlign"><img src="images/qtcreator-tooltip.png" alt="&quot;Tooltip&quot;" /></p><p>Tooltips can also contain full sentences. Try to make them as short and concise as possible, while still making them grammatically correct. Use sentence style capitalization and punctuation as you would for any sentence.</p>
<p class="centerAlign"><img src="images/qtcreator-tooltip-long.png" alt="&quot;Sentence as a tooltip&quot;" /></p><a name="writing-tooltips-in-design-mode"></a>
<h4 id="writing-tooltips-in-design-mode">Writing Tooltips in Design Mode</h4>
<p>In Qt Designer, use plain text for tooltips. For extra formatting, write short, canonical HTML in the source tab of the rich text editor: <code>&lt;html&gt;&lt;head/&gt;&lt;body&gt;&lt;b&gt;Note:&lt;/b&gt; text.</code></p>
<p>Qt Designer has a feature that simplifies the rich text (on by default), but still, you should verify by looking at the <b>Source</b> tab.</p>
<a name="writing-messages"></a>
<h3 id="writing-messages">Writing Messages</h3>
<p>Check that messages are concise and economically formulated. However, it is more important that the messages are useful and easy to understand.</p>
<p>Keep the use of many new and different sentence structures to a minimum. Reuse sentence structures that have been used in similar situations. For example:</p>
<ul>
<li>Cannot send log as selected message type. Text is too long.</li>
<li>Cannot receive image.</li>
<li>Cannot insert picture. Maximum text length is 120 characters.</li>
<li>Image name already in use.</li>
<li>Folder name already in use.</li>
</ul>
<a name="ui-text-capitalization"></a>
<h2 id="ui-text-capitalization">UI Text Capitalization</h2>
<p>Two styles are used, book title and sentence style:</p>
<ul>
<li>Example of Book Title Capitalization</li>
<li>Example of sentence style capitalization</li>
</ul>
<a name="using-book-style-capitalization"></a>
<h3 id="using-book-style-capitalization">Using Book Style Capitalization</h3>
<p>When using book style capitalization, capitalize all words, except prepositions that are shorter than five letters (for example, 'with' but 'Without'), conjunctions (for example, and, or, but), and articles (a, an, the). However, always capitalize the first and last word.</p>
<p>Use book style capitalization for:</p>
<ul>
<li>Titles (window, dialog, group box, tab, list view columns, and so on)</li>
<li>Functions (menu items, buttons)</li>
<li>Selectable items (combobox items, listbox items, tree list items, and so on)</li>
</ul>
<a name="checking-book-style-capitalization"></a>
<h4 id="checking-book-style-capitalization">Checking Book Style Capitalization</h4>
<p>You can use the to-title-case.js script in the <code>\doc\titlecase</code> folder to check book style capitalization of UI text or headings in documentation:</p>
<ol class="1" type="1"><li>Open to-title-case.html in a browser.</li>
<li>Enter the UI text in the field.</li>
<li>Click <b>Convert</b>.</li>
</ol>
<p>The UI text with suggested book style capitalization is displayed in the field to the right.</p>
<p><b>Note: </b>The script is based on word lists; it does not perform grammatical analysis. Therefore, it might get the capitalization wrong if you use a rare meaning of a word. For example, should you mean feathers and not direction when you write <i>down</i>. However, you should be able to trust it in most cases in the context of writing UI text and technical documentation.</p><a name="using-sentence-style-capitalization"></a>
<h3 id="using-sentence-style-capitalization">Using Sentence Style Capitalization</h3>
<p>When using sentence style capitalization, capitalize only the first letter, except proper names.</p>
<p>Use sentence style capitalization for:</p>
<ul>
<li>Labels</li>
<li>Tool tips</li>
<li>Descriptive text</li>
<li>Other non-heading or title text</li>
</ul>
<a name="preparing-for-localization"></a>
<h2 id="preparing-for-localization">Preparing for Localization</h2>
<p>Qt Creator is localized into several languages. Consistency and conciseness make UI text easier to translate.</p>
<a name="marking-ui-text-for-translation"></a>
<h3 id="marking-ui-text-for-translation">Marking UI Text for Translation</h3>
<p>Make sure the text strings presented to the user are easy to translate. The user interface text strings are enclosed in <code>tr()</code> calls and extracted from the source code during the translation process. Therefore, the translator might not know the source code context of the messages.</p>
<p>You can add comments that are visible in Qt Linguist ( //:) to clarify the context. For example:</p>
<pre class="cpp">

  <span class="comment">//: Contact book &quot;Add person&quot; button label</span>
  <span class="keyword">return</span> tr(<span class="string">&quot;Add&quot;</span>);

</pre>
<p>If the class is not <a href="http://doc.qt.io/qt-5/qobject.html#Q_OBJECT">Q_OBJECT</a>, use <code>QCoreApplication::translate(&quot;class context&quot;, &quot;message&quot;)</code> or consider using <a href="http://doc.qt.io/qt-5/qcoreapplication.html#Q_DECLARE_TR_FUNCTIONS">Q_DECLARE_TR_FUNCTIONS</a>. Do not use <code>QObject::tr()</code>, which is confusing because the messages appear grouped by class context in Qt Linguist and messages tied to <a href="http://doc.qt.io/qt-5/qobject.html">QObject</a> do not have a class context.</p>
<p>Use <code>QDir::toNativeSeparators()</code> for file and directory names that you pass to <code>tr().arg()</code>.</p>
<p>Do not use markup that spans the whole string, because that can be confusing for translators. For example, instead of:</p>
<pre class="cpp">

  tr(<span class="string">&quot;&lt;html&gt;&lt;head/&gt;&lt;body&gt;&lt;span&gt;UI Text&lt;/span&gt;&lt;/body&gt;&lt;/html&gt;&quot;</span>)

</pre>
<p>use</p>
<pre class="cpp">

  QLatin1String(<span class="string">&quot;&lt;html&gt;&lt;head/&gt;&lt;body&gt;&lt;span&gt;&quot;</span>) <span class="operator">+</span> tr(<span class="string">&quot;UI Text&quot;</span>) <span class="operator">+</span> QLatin1String(<span class="string">&quot;/span&gt;&lt;/body&gt;&lt;/html&gt;&quot;</span>)

</pre>
<a name="features-of-languages-or-writing-systems"></a>
<h3 id="features-of-languages-or-writing-systems">Features of Languages or Writing Systems</h3>
<p>To allow for localization of your extensions, consider the impact that languages and writing systems have on the implementation.</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Features of Languages or Writing Systems</th><th >Impact on Implementation</th></tr></thead>
<tr valign="top" class="odd"><td >Word order</td><td >Different languages have different word order rules.<p>Do not use run-time concatenation. Use complete phrases and &quot;%1&quot; formatting instead. For example, use:</p>
<p><code>tr(&quot;Foo failed: %1&quot;).arg(message)</code></p>
<p>instead of</p>
<p><code>tr(&quot;Foo failed: &quot;) + message</code></p>
</td></tr>
<tr valign="top" class="even"><td >Singular vs. plural vs. dual forms</td><td >Some languages do not have plural form (for example, Chinese and Japanese), whereas some have a different form for dual.<p>Allow room for text expansion in the layout design. Some languages need more space to indicate plurality or duality to convey the needed information.</p>
<p>For example, use</p>
<p><code>tr(&quot;%n files found&quot;, 0, number)</code></p>
<p>instead of</p>
<p><code>tr(&quot;%1 files found&quot;).arg(number)</code></p>
</td></tr>
<tr valign="top" class="odd"><td >Gender</td><td >Some languages have gender (feminine, masculine, neutral), whereas some do not (for example, Finnish) or do not use it extensively (for example, English).<p>Do not reuse text strings. The same term may not work in another context due to the gender of the base word.</p>
<p>Articles have a grammatical gender in some languages and sentences cannot be as easily constructed as in English. Avoid following types of constructs:</p>
<p><code>tr(&quot;%1 failed&quot;).arg(someCondition ? &quot;the operation&quot; : &quot;opening a file&quot;)</code></p>
</td></tr>
</table></div>
<a name="common-qt-creator-terms"></a>
<h2 id="common-qt-creator-terms">Common Qt Creator Terms</h2>
<p>This section summarizes the terminology used for common Qt Creator UI components. It also describes the conventions for naming different types of UI components.</p>
<p>Always check that the term you plan to use is not used to mean something else in the UI. If a suitable term already exists, use it. For example, use <i>Find</i> for searching and <i>New</i> for wizards that create new objects.</p>
<p>For more information on how to add UI components, see <a href="common-extension-tasks.html">Common Extension Tasks</a>.</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >UI Text</th><th >Usage</th><th >Conventions</th></tr></thead>
<tr valign="top" class="odd"><td >Context menu</td><td >Opens when users right-click on the screen. Contents depend on the context.<p class="centerAlign"><img src="images/qtcreator-context-menu.png" alt="&quot;Context menu&quot;" /></p></td><td >You can add menu items that are relevant in a particular context. Follow the conventions for naming menu items.</td></tr>
<tr valign="top" class="even"><td >Dialog</td><td >User interface element that usually contains a number of choices or allows the user to give input to the application. Opens when users select a menu item or button.<p class="centerAlign"><img src="images/qtcreator-dialog.png" alt="&quot;Dialog&quot;" /></p></td><td >Use the menu item or button name as the dialog name. You can also combine the menu item or button name and the name of the object that is managed in the dialog. For example, the <b>Add</b> button in the <b>Documentation</b> options opens the <b>Add Documentation</b> dialog.</td></tr>
<tr valign="top" class="odd"><td >Locator</td><td >Allows you to browse not only files, but any items defined by locator filters.<p class="centerAlign"><img src="images/qtcreator-locator.png" alt="&quot;Locator&quot;" /></p></td><td >You can add locator filters. Check that the filter is not already in use and give the filter a descriptive name.</td></tr>
<tr valign="top" class="even"><td >Menu</td><td >Contains menu items that represent commands or options and that are logically grouped and displayed. A menu can also contain submenus.<p class="centerAlign"><img src="images/qtcreator-menu.png" alt="&quot;Menu&quot;" /></p></td><td >You can create new menus. Use short, but descriptive names that are consistent with existing menu names. Use unambigious names.</td></tr>
<tr valign="top" class="odd"><td >Menu item</td><td >Represents a command or an option for users to choose.<p class="centerAlign"><img src="images/qtcreator-menu-item.png" alt="&quot;Menu item&quot;" /></p></td><td >You can add new items to menus. Use short, but descriptive names that are consistent with existing menu names. Use unambigious names.</td></tr>
<tr valign="top" class="even"><td >Message box</td><td >Dialog that provides feedback to users, in the form of status information, a warning, or an error message.<p class="centerAlign"><img src="images/qtcreator-error-message.png" alt="&quot;Message box&quot;" /></p><p>Output from Qt Creator should be displayed in output panes, instead.</p>
</td><td >Use the event as the title and provide a solution in the message box.</td></tr>
<tr valign="top" class="odd"><td >Mode</td><td >Modes correspond to complete screens of controls, specialized for a task.<p class="centerAlign"><img src="images/qtcreator-mode-selector.png" alt="&quot;Mode selector&quot;" /></p></td><td >You can add a mode for a new type of editor, for example. Use descriptive, but short mode names. They have to fit in the <b>Mode selector</b>.</td></tr>
<tr valign="top" class="even"><td >Output pane</td><td >A pane displayed in the task pane that displays output from Qt Creator.<p class="centerAlign"><img src="images/qtcreator-output-pane.png" alt="&quot;Output pane&quot;" /></p></td><td >Use descriptive names for output panes.</td></tr>
<tr valign="top" class="odd"><td >Sidebar</td><td >A view available in the <b>Edit</b> and <b>Debug</b> modes that you can use to browse projects, files, and bookmarks, and to view the class hierarchy.<p class="centerAlign"><img src="images/qtcreator-sidebar-menu.png" alt="&quot;Sidebar&quot;" /></p></td><td >You can add views to the sidebar menu. Use descriptive names for them.</td></tr>
<tr valign="top" class="even"><td >View</td><td >An area of the screen that displays information for users and provides them with functions for managing the information. Available in <b>Debug</b> mode, for interaction with the program that is running under the control of the debugger.<p class="centerAlign"><img src="images/qtcreator-debugger-views.png" alt="&quot;Views&quot;" /></p></td><td >Use descriptive names for views.</td></tr>
</table></div>
</div>
<!-- @@@qtcreator-ui-text.html -->
<p class="naviNextPrevious footerNavi">
<a class="prevPage" href="external-tool-spec.html">External Tool Specification Files</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="coding-style.html">Qt Creator Coding Rules</a>
</p>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
